//+------------------------------------------------------------------+
//|                                            SpearmanStack_X20.mq5 | 
//|                                  Copyright  2010, Ivan Kornilov | 
//|                                                 excelf@gmail.com | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Ivan Kornilov"
#property link "excelf@gmail.com"
#property description "SpearmanStack-X8"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----      
#property indicator_minimum -1
#property indicator_maximum +1
//----    
#property indicator_level1  +0.50
#property indicator_level2   0
#property indicator_level3  -0.50
#property indicator_levelcolor clrRed
#property indicator_levelstyle STYLE_DASHDOTDOT
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define LINES_TOTAL         20 //     
#define RESET               0 //        
//----   
#property indicator_buffers LINES_TOTAL 
//----    
#property indicator_plots   LINES_TOTAL

//+-----------------------------------+
//|      |
//+-----------------------------------+
//----     
#property indicator_type1 DRAW_LINE
//----   
#property indicator_color1 clrDodgerBlue
//----  -  
#property indicator_style1 STYLE_SOLID
//----   1
#property indicator_width1  1
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint  rangeN=14;
input uint  step = 6;
input uint  CalculatedBars=0;
uint  Maxrange;
input bool  direction=true;
//+-----------------------------------+

//----      
int Spear_Handle[LINES_TOTAL];
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+  
class CIndicatorsBuffers
  {
public: double    IndBuffer[];
  };
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
CIndicatorsBuffers Ind[LINES_TOTAL];
//+------------------------------------------------------------------+   
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   min_rates_total=int(rangeN+step*(LINES_TOTAL-1))+1;
   Maxrange=rangeN+LINES_TOTAL*(step-1+1)*2;
//----
   uint period=rangeN;
   for(int numb=0; numb<LINES_TOTAL; numb++)
     {
      period+=step;

      //----    SpearmanRankCorrelation
      Spear_Handle[numb]=iCustom(NULL,0,"SpearmanRankCorrelation",period,CalculatedBars,Maxrange,direction);
      if(Spear_Handle[numb]==INVALID_HANDLE) Print("      SpearmanRankCorrelation ",numb);

      string shortname="";
      StringConcatenate(shortname,"SpearmanRankCorrelation X",LINES_TOTAL,"*",period,")");
      //---           
      PlotIndexSetString(numb,PLOT_LABEL,shortname);
      //----   ,      
      PlotIndexSetDouble(numb,PLOT_EMPTY_VALUE,EMPTY_VALUE);
      //----      
      PlotIndexSetInteger(numb,PLOT_DRAW_BEGIN,min_rates_total);
      //----      
      SetIndexBuffer(numb,Ind[numb].IndBuffer,INDICATOR_DATA);
      //----          
      ArraySetAsSeries(Ind[numb].IndBuffer,true);
      //----        
      PlotIndexSetInteger(numb,PLOT_DRAW_TYPE,PlotIndexGetInteger(0,PLOT_DRAW_TYPE));
      PlotIndexSetInteger(numb,PLOT_LINE_STYLE,PlotIndexGetInteger(0,PLOT_LINE_STYLE));
      PlotIndexSetInteger(numb,PLOT_LINE_WIDTH,PlotIndexGetInteger(0,PLOT_LINE_WIDTH));
      PlotIndexSetInteger(numb,PLOT_LINE_COLOR,PlotIndexGetInteger(0,PLOT_LINE_COLOR));
     }

//----      
   string shortname;
   StringConcatenate(shortname,"SpearmanRankCorrelation X",LINES_TOTAL,"*",rangeN,"(",step,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);

//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(RESET);
   for(int numb=0; numb<LINES_TOTAL; numb++) if(BarsCalculated(Spear_Handle[numb])<min_rates_total) return(RESET);

//----    
   int to_copy;

//----     
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      to_copy=rates_total;
   else to_copy=rates_total-prev_calculated+1;

//----       
   for(int numb=0; numb<LINES_TOTAL; numb++) if(CopyBuffer(Spear_Handle[numb],0,0,to_copy,Ind[numb].IndBuffer)<=0) return(RESET);
   
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
